static void acc_data_send(void)
{
    uint32_t err_code;

    if (!m_is_sending_data)
    {
        return;
    } // IF SENDING WAS DISABLED (BY PRESSING BUTTON), METHOD SHOULDN'T BE RUNNING ANYMORE

    uint8_t reg = OUT_X_L;

    if(tempi != 0 && tempi < 6){

        for (uint8_t i = tempi; i < 6; i++){
            d[step] = temp[i];
            step++;
        }
    }
    tempi = 0;

    if(!has_gotten_data){
        err_code = nrf_drv_twi_tx(&m_twi_lis331hh, LIS331HH_ADDR, &reg, sizeof(reg), true);
        APP_ERROR_CHECK(err_code);
        m_xfer_done = false;
    }
    while(true){
        char *str = malloc(sizeof(char) * 200);
        do
        {
            __WFE();
        }while(m_xfer_done == false); // wait until next measuring is over
        uint32_t err_code;
        if(tempi != 0 && tempi < 6){
            SEGGER_RTT_WriteString(0, str);
            for (uint8_t i = tempi; i < 6; i++){
                d[step] = temp[i];
                step++;
            }
        }
        tempi = 0;

        temp[0] = m_sample.x.low;
        temp[1] = m_sample.x.high;
        temp[2] = m_sample.y.low;
        temp[3] = m_sample.y.high;
        temp[4] = m_sample.z.low;
        temp[5] = m_sample.z.high;

        for (uint8_t i = step; i < step+6; i++){
            if(i<BLE_LBS_DATA_CHAR_LEN){
                d[i] = temp[tempi];
                tempi++;
                if(i==19){
                    isFull = true; //!!!! Otherwise, even though the packet will now be full, the else clause will have not been called how as a result another measure will be done that's not put in the packet
                }
            }
            else{
                isFull = true;
                break;
            }
        }
        step += 6;

        if(isFull){
            isFull = false;
            step = 0;
            nrf_gpio_pin_toggle(0);
            err_code = ble_lbs_data_send(&m_our_service, d); 
            if (err_code == NRF_SUCCESS && m_is_sending_data) // Until buffer is full of packets, keep measuring and setting ready to send. Make sure that BLE knows that I have more data to send by overflowing the buffer with a 4th packet
            {
                err_code = nrf_drv_twi_tx(&m_twi_lis331hh, LIS331HH_ADDR, &reg, sizeof(reg), true);
                APP_ERROR_CHECK(err_code);
                m_xfer_done = false;

            }
            else{
                break;
            }
        }
        else{
            err_code = nrf_drv_twi_tx(&m_twi_lis331hh, LIS331HH_ADDR, &reg, sizeof(reg), true);
            APP_ERROR_CHECK(err_code);
            m_xfer_done = false;
        }
        free(str);
    }
}

uint32_t ble_lbs_data_send(ble_os_t * p_lbs, uint8_t data[BLE_LBS_DATA_CHAR_LEN])
{
    ble_gatts_hvx_params_t params;
    uint16_t len = BLE_LBS_DATA_CHAR_LEN;
    
    memset(&params, 0, sizeof(params));
    params.type = BLE_GATT_HVX_NOTIFICATION;
    params.handle = p_lbs->char_handles.value_handle;
    params.p_data = data;
    params.p_len = &len;
    /*char *str = malloc(sizeof(char) * 200);    //Printing their order here and here it is still correct
    int16_t s = data[0] | (data[1] << 8);
    sprintf(str, "%3f\n",s*0.0007324/4); 
    SEGGER_RTT_WriteString(0, str);
    free(str);*/    
    return sd_ble_gatts_hvx(p_lbs->conn_handle, &params);
}